/****************************************************************************/
/*                                                                          */
/*    File.c      File i/o routines for MaxMail                             */
/*                                                                          */
/****************************************************************************/

#include "MaxMail.h"

struct msgupd_st *msgupd;
struct msgupd_st *next;
struct proto_st *proto1;
struct repupl_st *upl1;
struct packer_st *packer1;
struct reparc_st *reparc1;
struct stat fbuf;
char fname[_MAX_PATH];
char exec_ret;
int comhandle = -1;
int FirstArc = 1;

int Command = FALSE;

void _interrupt _far CheckWatch(void);
void (_interrupt _far *OldTimer)(void);

static int Critseg,Critoffs;

char *packtemp;
char *arccmndline;

/* Load up user message areas data into linked list */

int _pascal build_areas(int mode,int output)
{
   int keys,mask,x,anum;
   int index,count;
   word *bitp;
   struct _aidx IDX;

   count = 0;
   if (PackDone)
      return(0);

   msgupd = MSGUPD_1;
   USERCFG.totselareas = 0;
   while (msgupd) {
      next = msgupd->next;
      free(msgupd);
      msgupd = next;
   }


   MSGUPD_1 = NULL;		/* Set up linked list */
   anum = 0;
   index = sopen(PRM(aidx_name),O_BINARY | O_RDONLY,SH_DENYNO,S_IREAD);
   if (index == -1)
      aborterror(FILEOPEN,"Error opening Area index file");
   keys = read(index,(char *)&IDX,sizeof(struct _aidx));
   if(fseek(afile,IDX.offset,SEEK_SET) == 0) {
      fread(&AREA,astrlen,1,afile);
      if (output)
         strout("\r\n");
   }
   else keys = FALSE;
   while (keys == sizeof(struct _aidx)) {
      bitp = &USERCFG.msgarea[anum / 16];
      mask = 1;
      for (x=0; x < (anum % 16); x++)
         mask = mask << 1;
      keys = testlock();
      if (isskiparea(anum))
         keys = FALSE; 		/* If Sysop set skip, don't build this area */
      if (isForcearea(anum)) 		/* Force this area */
         *bitp |= mask;		/* Force area to be turned on */
      if (AREA.msgpath[0] && (LastUser.priv >= AREA.msgpriv) && keys) {
         count++;		/* Possible areas count */
         if (*bitp & mask) {		/* User has selected this area */
            if(check_barareas(&AREA,mode)) {
               totmsgareas++;
               msgupd = (struct msgupd_st *) malloc(sizeof(struct msgupd_st));
               if (msgupd == NULL)
                  aborterror(BADALLOC,NULL);
               if (MSGUPD_1 == NULL) 
                  MSGUPD_1 = msgupd;		/* Link in top of pointer */
               else MSGUPD_cur->next = msgupd;
               msgupd->areano = anum;
               msgupd->flags = 0;
               msgupd->attribute = (word) AREA.attrib[UserClass];
               strcpy(msgupd->msgpath,AREA.msgpath);
               msgupd->update = FALSE;
               switch (AREA.area_type) {
                  case 0:		/* Fido 1.msg style */
                     msgupd->himsg = find_fidohigh(AREA.msgpath);
                     break;

                  default:
                     msgupd->himsg = find_fidohigh(AREA.msgpath);
                     break;
               }
               if (msgupd->himsg < 0  )
                  msgupd->himsg = 0;
               msgupd->areaindex = ftell(afile) - (long) astrlen;	/* Position */
               msgupd->next = NULL;
               msgupd->startmsg = 1;
               msgupd->readmsgs = 0;
               msgupd->msgcount = 0;
               if (isForcearea(anum))
                  msgupd->flags |= AREA_FORCED;
               MSGUPD_cur = msgupd;
               if (msgupd->himsg) {
                  msgupd->startmsg = get_lastread(AREA.msgpath);
                  if (msgupd->startmsg > msgupd->himsg) 
                     msgupd->startmsg = msgupd->himsg;
                  if (msgupd->startmsg < 1)
                     msgupd->startmsg = 1;
                  msgupd->msgcount = msgupd->himsg - msgupd->startmsg;
               }
               if (output) {
                  sprintf(temp,"\rArea %d: ",anum);
                  strncat(temp,AREA.msginfo,35);
                  for (x = 45 - strlen(temp); x; x-- )
                     strcat(temp," ");
                  strout(temp);
               }
            }
            else {		/* Deselect area */
               mask ^= 0xffff;		/* Reverse mask */
               *bitp &= mask;		/* Turn area off if barricaded rejected */
            }
         }
         else {		/* User has area turned on, but it's no valid. Turn it off */
            mask ^= 0xffff;		/* Reverse mask */
            *bitp &= mask;		/* Turn area off if barricaded rejected */
         }
      }
      else {		/* it's not a message area */
         if (*bitp & mask) {		/* User has selected this area */
            mask ^= 0xffff;		/* Reverse mask */
            *bitp &= mask;		/* Turn area off if invalid */
         }
      }
      anum++;
      keys = read(index,(char *)&IDX,sizeof(struct _aidx));
      if (keys == sizeof(struct _aidx)) {
         if(fseek(afile,IDX.offset,SEEK_SET) == 0)
            fread(&AREA,astrlen,1,afile);
         else keys = FALSE;
      }
   }
   if (output)
      strout("\r\n");
   close(index);
   USERCFG.totselareas = totmsgareas;
   USERCFG.totareas = count;
   return(count);
}

/* Scan message areas,build capture file */

int _pascal scan_msgs()
{
   int x,y,firsttime;
   FILE *headfile;
   FILE *statfile;
   FILE *sfile;
   struct msghead *MSGHD;

   if (MSGUPD_1 == NULL) {
      setcolor(TextAttr[ATTN_TEXT]);
      logit("User has no message areas selected",'!');
      strout("\r\nYou have no valid message areas selected.");
      strout("\r\nSelect [C] at menu prompt and change your configuration\r\n");
      return(FALSE);
   }

   if (PackDone)
      return(FALSE);

   if (USERCFG.msgfrmt == 0) {
      if (Task) {		/* Rename TxtFile to have tasknumber */
         _splitpath(TxtFile,hdrive,hdir,temp,temp1);
         temp[6] = 0;		/* Trim out 2 chars */
         sprintf(TxtFile,"%s%02x%s",temp,Task,temp1);
      }
      if (tdir[0]) {
         sprintf(temp1,"%s\\%s",tdir,TxtFile);
         outfile = _fsopen(temp1,"w+",SH_DENYNO);
      }
      else outfile = _fsopen(TxtFile,"w+",SH_DENYNO);
      if (outfile == NULL) {
         sprintf(temp1,"Error creating %s",TxtFile);
         aborterror(FILECREATE,temp1);
      }
   }
   else {		/* QWK style */
      if(openqwk()) {
         sprintf(temp1,"Error creating QWK packet");
         aborterror(FILECREATE,temp1);
      }
      statfile = NULL;
      outfile = NULL;
      SumFile[0] = 0;
   }

   MSGHD = (struct msghead *) malloc(sizeof(struct msghead));
   if (MSGHD == NULL)
      aborterror(BADALLOC,NULL);
   MSGHD->answers = NULL;
   strcpy(MSGHD->ourname,LastUser.name);

   totmsgs = 0;
   firsttime = TRUE;
   msgupd = MSGUPD_1;
   while (msgupd) {
      fseek(afile,msgupd->areaindex,SEEK_SET);
      fread(&AREA,astrlen,1,afile);
      if (firsttime) {
         if (USERCFG.msgfrmt == 0) {
            fprintf(outfile,"\n MaxMail Version %.2f Custom message archive for %s\n",Version,USERCFG.name);
            fprintf(outfile," ---> Messages were captured on %s\n",timestring());
            if (MsgHdrFile[0]) {		/* Sysop wants to put in a message header file */
               headfile = _fsopen(MsgHdrFile,"rt",SH_DENYNO);
               if (headfile == NULL) 
                  logit("Message Header file could not be opened.",'!');
               else {
                  fgets(temp,80,headfile);
                  while (!feof(headfile)) {
                     fputs(temp,outfile);
                     fgets(temp,80,headfile);
                  }
                  fclose(headfile);
               }
            }
            if (StatName[0]) {
               if (Task) {
                  sprintf(temp,".%x",Task);
                  strcat(StatName,temp);
               }
               if (tdir[0]) {
                  sprintf(temp,"%s\\%s",tdir,StatName);
                  statfile = _fsopen(temp,"wt",SH_DENYNO);
               }
               else statfile = _fsopen(StatName,"wt",SH_DENYNO);
            }
            else statfile = NULL;
            if (SumFile[0]) {
               if (tdir[0]) {
                  sprintf(temp,"%s\\%s",tdir,SumFile);
                  unlink(temp);
               }
               else unlink(SumFile);
            }
         }
         setcolor(TextAttr[STD_TEXT]);
         strout("\r\n--------[ Grinding the sysop's disk now ]-----------------");
         strout("\r\n                              Start    High   New     Your");
         strout("\r\nMessage Area                    Msg     Msg   Msgs    Msgs");
         strout("\r\n----------------------------------------------------------\r\n");
         if (statfile != NULL && USERCFG.msgfrmt == 0) {
            fprintf(statfile,"\n-----------------[ MaxMail Statistics ]-------------------");
            fprintf(statfile,"\n                              Start    High   New     Your");
            fprintf(statfile,"\nMessage Area                    Msg     Msg   Msgs    Msgs");
            fprintf(statfile,"\n----------------------------------------------------------\n");
         }
         firsttime = FALSE;
      }
      msgupd->readmsgs = 0;
      if (msgupd->msgcount > 0) 	{	/* If there are messages in this area */
         MSGHD->ourmail = 0;
         if (MSGHD->answers != NULL)
            free(MSGHD->answers);
         MSGHD->answers = NULL;
         x = load_area(msgupd,statfile,MSGHD);		/* Return lastread msgnum */
         if (msg_update) {
            msgupd->update = TRUE;
            msgupd->readmsgs = x - msgupd->startmsg;		/* Establish last message read */
         }
         if (MSGHD->ourmail) {
            setcolor(TextAttr[MENU_KEY]);
            sprintf(temp,"      You have %d personal messages in this area.\r\n",MSGHD->ourmail);
            strout(temp);
            if (USERCFG.msgfrmt == 0 && statfile != NULL) {
               fprintf(statfile,"      You have %d personal messages in this area. See messages: \n",MSGHD->ourmail);
               y = 0;
               fprintf(statfile,"      ");
               setcolor(TextAttr[STD_TEXT]);
               for (x = 0; x < (int) MSGHD->ourmail; x++) {
                  if (x < (int) (MSGHD->ourmail - 1))
                     fprintf(statfile,"%d,",MSGHD->answers[x]);
                  else fprintf(statfile,"%d",MSGHD->answers[x]);
                  if(++y > 20) {
                     fprintf(statfile,"\n      ");
                     y = 0;
                  }
               }
               fprintf(statfile,"\n");
            }
         }
      }
      if ((unsigned) totmsgs >= MaxMsgs) {
         setcolor(TextAttr[ATTN_TEXT]);
         sprintf(temp1,"\r\nPoof! You've gobbled up the maximum # of messages (%d) for this run\r\n",totmsgs);
         strout(temp1);
         if (LogMode == VERBOSE)
            logit("User has used up maximum messages for this run",'#');
         break;
      }
      msgupd = msgupd->next;
   }
   setcolor(TextAttr[HILITE_TEXT]);
   if (USERCFG.msgfrmt == 0) {
      fprintf(outfile," \n\n ---> %d Total messages were captured <---\n",totmsgs);
      fclose(outfile);
      if (statfile != NULL) {
         if (tdir[0]) {
            sprintf(temp1,"%s\\%s",tdir,SumFile);
            sfile = _fsopen(temp1,"rt",SH_DENYNO);
         }
         else sfile = _fsopen(SumFile,"rt",SH_DENYNO);
         if (SumFile[0] && sfile != NULL) {
            while (!feof(sfile)) {
               if(fgets(temp1,80,sfile) != NULL)
                  fputs(temp1,statfile);
            }
            fclose(sfile);
         }
         fclose(statfile);
      }
      if (SumFile[0]) {
         if (tdir[0]) {
            sprintf(temp,"%s\\%s",tdir,SumFile);
            unlink(temp);
         }
         else unlink(SumFile);
      }
   }
   else {		/* QWK format */
      closeqwk();		/* Clean up things */
   }
   if (MSGHD->answers != NULL)
      free(MSGHD->answers);
   free(MSGHD);
   return(TRUE);
}

/* Scan individual message area,called from Scan_msgs(), get
   message text and write to capture file, stats file */

int _pascal load_area(struct msgupd_st *msgupd,FILE *statfile,struct msghead *MSGHD)
{
   int x,y,msgcount,divisor,lastmsg;
   int forward,fidoflags,msgtot,color;
   FILE *sumfile = NULL;

   if (msgupd->himsg > 0) {
      color = 0;		/* Activity divit color rotate */
      lastmsg = msgupd->startmsg;
      if (USERCFG.msgfrmt == 0) {
         fprintf(outfile,"\n\n\n *************************************************************\n");
         if (AREA.attrib[UserClass] & ECHOMAIL) 
            sprintf(temp," ** Echomail Area %s - %s ",AREA.name,AREA.msginfo);
         else sprintf(temp," ** Local/Public Area %s - %s ",AREA.name,AREA.msginfo);
         while (strlen(temp) < 60)
            strcat(temp," ");
         strcat(temp,"**");
         fprintf(outfile,"%s\n",temp);
         fprintf(outfile," *************************************************************\n");
      }
      strncpy(temp1,AREA.msginfo,24);
      temp1[24] = 0;
      while (strlen(temp1) < 24)
         strcat(temp1," ");
      sprintf(temp,"[%03d] %s %04u    %04u   %04u     ",msgupd->areano,temp1,msgupd->startmsg,msgupd->himsg,msgupd->msgcount);
      if (statfile != NULL)
         fprintf(statfile,"[%03d] %s %04u    %04u   %04u    ",msgupd->areano,temp1,msgupd->startmsg,msgupd->himsg,msgupd->msgcount);
      if (SumFile[0]) {
         if (tdir[0]) {
            sprintf(temp1,"%s\\%s",tdir,SumFile);
            sumfile = _fsopen(temp1,"at",SH_DENYNO);
         }
         else sumfile = _fsopen(SumFile,"at",SH_DENYNO);
         if (statfile != NULL) {
            fprintf(sumfile,"\n\n************ Message Subject Summary ************************\n");
            if (AREA.attrib[UserClass] & ECHOMAIL) 
               sprintf(temp1,"** Echomail Area %s - %s ",AREA.name,AREA.msginfo);
            else sprintf(temp1,"** Local/Public Area %s - %s ",AREA.name,AREA.msginfo);
            while (strlen(temp1) < 59)
               strcat(temp1," ");
            strcat(temp1,"**");
            fprintf(sumfile,"%s\n",temp1);
            fprintf(sumfile,"*************************************************************\n");
            fprintf(sumfile,"Msg#    From                                  Subject\n");
            fprintf(sumfile,"-------------------------------------------------------------\n");
         }
         
      }
      setcolor(TextAttr[STD_TEXT]);
      strout(temp);
      msgcount = 0;
      forward = 1;		/* Activity flag */

      fidoflags = 0;

      if (LastUser.priv < ASSTSYSOP && !(msgupd->attribute & NOPRIVATE)) 
         fidoflags |= PRIVATE;

/* If non-echomail area, start at message #1 */

      if (!(AREA.attrib[UserClass] & ECHOMAIL) && msgupd->startmsg == 1) 
         msgupd->startmsg = 0;

      msgtot = msgupd->himsg - msgupd->startmsg;  /* Total poss messages in area */
      for (x=msgupd->startmsg+1; x <= (int) msgupd->himsg && ((unsigned) totmsgs < MaxMsgs); x++) {
         if ((msgtot - msgcount) > 40)		/* Total messages in this area */
            divisor = 2;
         else divisor = 1;		/* Flip activity flag more */
         MSGHD->subject[0] = 0;
         switch (AREA.area_type) {
            case 0:		/* Fido 1.msg style */
               if (USERCFG.msgfrmt == 0) 
                  y = file_fidomsg(x,fidoflags,outfile,msgupd,MSGHD);
               else y = qwk_fidomsg(x,fidoflags,msgupd,MSGHD);
               break;

            default:
               if (USERCFG.msgfrmt == 0) 
                  y = file_fidomsg(x,fidoflags,outfile,msgupd,MSGHD);
               else y = qwk_fidomsg(x,fidoflags,msgupd,MSGHD);
               break;
         }

         if (y < 0) {		/* Some kind of error */
            if (y == PVTMSG_ERR) 		/* No real error, just a private msg */
               continue;
            else continue;		/* This is redundant for now! */
         }
         else {		/* A message was read */
            lastmsg = y;
            if (sumfile != NULL) {		/* Muck with the summary file */
               sprintf(temp1,"%d",y);
               while (strlen(temp1) < 8 )
                  strcat(temp1," ");
               fprintf(sumfile,"%s",temp1);
               sprintf(temp1,"%s",MSGHD->from);
               while (strlen(temp1) < 36 )
                  strcat(temp1," ");
               fprintf(sumfile,"%s  ",temp1);
               strncpy(temp1,MSGHD->subject,34);
               temp1[34] = 0;
               fprintf(sumfile,"%s\n",temp1);
            }
            msgcount++;
            totmsgs++;
         }
         if (!(msgcount % 10)) {		/* Show 10 count */
            setcolor(TextAttr[HILITE_TEXT]);
            sprintf(temp1,"  %4d",msgcount);
            strout(temp1);
            strout("\b\b\b\b\b\b");		/* Restore position to divit */
         }
         if (!(msgcount % divisor)) {		/* A little activity display logic */
            setcolor(TextAttr[color]);
            switch (forward) {
               case 1:
                  strout("\b|");
                  forward++;
                  break;

               case 2:
                  strout("\b/");
                  forward++;
                  break;

               case 3:
                  strout("\b-");
                  forward++;
                  break;

               case 4:
                  strout("\b\\");
                  forward = 1;
                  break;
            }
            if (++color > (TOTALCOLORS - 1))
               color = 0;		/* Restart */
            if (color == ATTN_TEXT)
               color++;
         }
         if (USERCFG.maxareamsgs != 0 && (USERCFG.msgfrmt == 1)) {
            if((word) msgcount >= USERCFG.maxareamsgs) 
               break;		/* We must stop here! */
         }
      }
      if (!msgcount)	{	/* No messages in this area */
         setcolor(TextAttr[ATTN_TEXT]);
         strout("\bNew msgs are private!\r\n");
         lastmsg = msgupd->himsg;		/* Force himsg update */
      }
      else {
         if (msgcount >= 3) 
            strout("\b ");
         sprintf(temp,"\b%04d              \r\n",msgcount);
         setcolor(TextAttr[HILITE_TEXT]);
         strout(temp);
         if (statfile != NULL)
            fprintf(statfile,"%04d\n",msgcount);
      }
   }
   if (sumfile != NULL)
      fclose(sumfile);
   setcolor(TextAttr[STD_TEXT]);
   return lastmsg;
}

/* Pack user capture file & summary file into designated packer */

int _pascal Packit(void)
{
   int x,old;
   FILE *new;
   char *p,*p1;
   struct find_t c_file;

   PackDone = FALSE;

   sprintf(temp1,"\r\n\r\nNow packing up %d messages\r\n",totmsgs);
   setcolor(TextAttr[STD_TEXT]);
   strout(temp1);
   strout("Please wait while I call the packer program.....\r\n");
   if (USERCFG.msgfrmt == 0) {
      makearc(TxtFile);		/* Add Text file to archive */
      if (StatName[0]) {
         if (comhandle < 0) 
            strout("Hang on! I am now adding the MSGSTATS file to the archive\r\n");
         makearc(StatName);		/* Add stat file to archive */
      }
/* Include newfiles list option */
      if ((USERCFG.flags & NEWFILES_INC) && NewFiles[0]) {
         if (comhandle < 0) 
            strout("Hang on! I am now adding the NEWFILES list to the archive. We're almost done..\r\n");
         makearc(NewFiles);
      }
   }
   else {		/* QWK format */
      if ((USERCFG.flags & NEWFILES_INC) && NewFiles[0]) {
         if (tdir[0])
            sprintf(temp1,"%s\\",tdir);
         if (QWKDir[0]) {
            strcat(temp1,QWKDir);
            strcat(temp1,"\\");
         }
         strcat(temp1,"NewFiles.dat");		/* Build full path */
         if(copyfile(NewFiles,temp1))		/* Source to dest */
            NewFiles[0] = 0;
      }
      copy2temp(QWKnews);		/* Copy all these files if they exist */
      copy2temp(QWKbye);
      copy2temp(QWKWelcome);

      if (!_dos_findfirst("blt-*.*",_A_NORMAL,&c_file)) {	/* copy the bulletins */
         copy2temp(c_file.name);
         while (!_dos_findnext(&c_file)) 
            copy2temp(c_file.name);
      }
      makearc("*.*");
   }

   if ((USERCFG.flags & NEWFILES_INC) && NewFiles[0])
      logit("Adding NEWFILES list to user packet",'#');

   if (packer1->viewstring && comhandle < 0 && !IsLocal) { 		/* Call up packer again, showing viewline */
      setcolor(TextAttr[STD_TEXT]);
      if (SwapMode)
         sprintf(temp," /c %s",packer1->packexe);
      else strcpy(temp," ");
      strcpy(temp1,packer1->viewstring);
      p = strtok(temp1,"%");		/* Up to 1st token */
      strcat(temp,p);
      strcat(temp," ");
      p1 = strtok(NULL,"%");		/* Up to 2nd token */
      if (tolower(p1[0]) == 'a') 		/* Arcfile */
         strcat(temp,ArcFile);
      strcat(temp," ");
      p1 = strtok(NULL,"\0");		/* Get rest of line */
      if (p1) strcat(temp,p1);

      printf("Command line: %s %s\n",fname,temp);

      tempdir();

      old = dup(1);		/* old now refers to stdout */
      if (!IsLocal) {
         sprintf(temp1,"tmpmax%02x",Task);
         new = _fsopen(temp1,"w+",SH_DENYWR);		/* Reroute stdout to file */
         dup2(fileno(new),1);		/* Reroute stdout to file */
      }

/* Execute the ARCHIVE viewing command */
      if (SwapMode) {
         sprintf(temp1,"Maxmal%02x.swp",Task);
         x = swap(fname,temp,&exec_ret,temp1);
      }
      else {		/* We must do a DOS exec function */
         strcpy(temp1,fname);
         strcat(temp1," ");
         strcat(temp1,temp);
         x = system(temp1);
         exec_ret = (char) x;
      }

      if (!IsLocal) {
         dup2(old,1);		/* Restore stdout */
         fclose(new);
/* Now display tmp file to user */
         sprintf(temp1,"tmpmax%02x",Task);
         show_file(temp1,FALSE);
         unlink(temp1);
      }
      homedir();
      check_carrier();
   }

   sprintf(temp,"Packing up %d messages using %s",totmsgs,packer1->packexe);
   logit(temp,'#');

   PackDone = TRUE;		/* Say yes, it's accepted */

   if (comhandle >= 0) {
      close(comhandle);
      comhandle = -1;
   }

   if (USERCFG.msgfrmt == 1) {
      tempdir();
      sprintf(temp,"%s.qwk",BBSid);
      rename(ArcFile,temp);
      strcpy(ArcFile,temp);
      homedir();
   }

   tempdir();
   stat(ArcFile,&fbuf);
   homedir();
   sprintf(temp,"%s is %lu bytes",ArcFile,fbuf.st_size);
   logit(temp,'#');

   return(TRUE);
}

/* Transmit user archive file, with designated protocol engine */
int _pascal sendit(void)
{
   int x;
   long calc;
   char *p,*p1;
   char portstr[3];


   x = USERCFG.protocol;		/* Save current protocol type */
   if (!x)
      get_proto(FALSE);

   proto1 = get_curprotolnk();
   USERCFG.protocol = (byte) x;

   _searchenv(proto1->protoexe,"PATH",fname);

   strcpy(temp1,proto1->protostring);
   p = strtok(temp1,"%");		/* Up to 1st token */
   strcpy(temp,p);
   p1 = strtok(NULL,"%");		/* Up to 2nd token */

/* Parse protocol string and build command line */
   while (*p1) {
      switch (tolower(p1[0])) {
         case 'a':
            strcat(temp,ArcFile);
            break;

         case 'p':
            sprintf(portstr,"%d",prm.com_port + 1);		/* Com1 or com2 */
            strcat(temp,portstr);
            break;

         case 'b':
            sprintf(portstr,"%d",LastUser.flag);		/* Baudrate */
            strcat(temp,portstr);
            break;

         default:
            strcat(temp,p1);
            break;
      }
      p1++;
      if (*p1)
         strcat(temp,p1);
      strcat(temp," ");
      p1 = strtok(NULL,"%");		/* Up to 2nd token */
   }


   tempdir();
   stat(ArcFile,&fbuf);
   homedir();

   setcolor(TextAttr[HILITE_TEXT]);
   sprintf(temp1,"\r\nPacked message file (%s) is %lu bytes\r\n",ArcFile,fbuf.st_size);
   strout(temp1);
   calc = (long) get_kminute();
   if (calc) {
      calc = fbuf.st_size / calc;
      if (calc <= 0)
         calc = 1;
   }
   else calc = 1;

   if (!IsLocal) {
      setcolor(TextAttr[HILITE_TEXT]);
      sprintf(temp1,"It will take about %ld minute(s) to download\r\n",calc);
      strout(temp1);
   }
   else Hangup = 0;
   setcolor(TextAttr[PROMPT_TEXT]);

   if (!IsLocal) {
      if (Hangup && !(USERCFG.flags & DLHANGUP)) {
         strout("Are you sure you want to download it?\r\n");
         strout("(Y)es,(N)o,(H)ang up after download [Y,n,h] -> ");
      }
      else {
         if (!Hangup && (USERCFG.flags & DLHANGUP)) {
            setcolor(TextAttr[ATTN_TEXT]);
            strout("Sysop has turned OFF the hangup after download option.\r\n");
            setcolor(TextAttr[PROMPT_TEXT]);
         }
         strout("Are you sure you want to download it? [Y,n] -> ");
      }
   }
   else strout("Are you sure you want to keep this message packet? [Y,n] -> ");

   x = chrin();
   if (isalpha(x))
      x &= 0x00df;		/* Force upper case, toupper() has side effects */
   chrout((char) x);
   strout("\r\n");
   if (x == '\r')
      x = 'Y';

   if ( x == 'Y' || x == 'H') {
      if (IsLocal) {
         USERCFG.packcount++;
         if (packer_del) {
            setcolor(TextAttr[ATTN_TEXT]);
            strout("\nUnfortunately, you did NOT specify /N switch so message packet\n");
            strout("  will be deleted after exit!\n");
            setcolor(TextAttr[STD_TEXT]);
         }
         else {
            strout("\nMessage packet will remain on the local disk after exit.\n");
            Exitcode = 7;
         }
         return TRUE;
      }

      if (x == 'Y' && Hangup && !(USERCFG.flags & DLHANGUP))
         Hangup = 0;

      if (x == 'H' && Hangup)
         Hangup = 1;		/* User want's hangup */

      sprintf(temp1,"Transmit %s using %s",ArcFile,proto1->protoname);
      logit(temp1,'=');

      sprintf(temp1,"Prepare to download %s using %s \r\n",ArcFile,proto1->protoname);
      strout(temp1);
      delay_s(2);		/* Make sure string is displayed to user */

      printf("Command line: %s %s\n",fname,temp);

   /* Execute the protocol engine */
      FossilDeInit();		/* Remove fossil from us */

      tempdir();

      if((USERCFG.flags & DLHANGUP) && Hangup)
         Hangup = 1;

      if (SwapMode) {
         sprintf(temp1,"Maxmal%02x.swp",Task);
         x = swap(fname,temp,&exec_ret,temp1);
      }
      else {		/* We must do a DOS exec function */
         strcpy(temp1,fname);
         strcat(temp1,temp);
         x = system(temp1);
         exec_ret = (char) x;
      }

      homedir();
      FossilInit();		/* Restart fossil for us */

      if (x || exec_ret) {
         setcolor(TextAttr[ATTN_TEXT]);
         strout("\r\n\r\nOh Oh! Xfer program had some kind of error\r\n");
         sprintf(temp,"Xfer pgm error code: %d, swap error: %d",exec_ret,x);
         logit(temp,'!');
         if (Hangup == 1)
            Hangup = 2;		/* Disable hangup */
         return FALSE;		/* Allow user to retry transmission */
      }
      else {
         USERCFG.dailycount += 1;
         setcolor(TextAttr[HILITE_TEXT]);
         strout("\r\nNo errors occured during transfer.\r\n");
         USERCFG.packcount++;
         return(TRUE);
      }
   }
   else return FALSE;
}

int _pascal repupload(void)
{
   int x;
   char *p,*p1;
   char portstr[3];
   char tname[14];

   if (!IsLocal) {
      x = USERCFG.protocol;		/* Save current protocol type */
      get_proto(FALSE);		/* Force protocol question for uploads */
      upl1 = get_curreplnk();
      USERCFG.protocol = (byte) x;
   }
   else upl1 = REPUPL_1;


   _searchenv(upl1->protoexe,"PATH",fname);

   sprintf(tname,"%s.rep",BBSid);

   strcpy(temp1,upl1->protostring);
   p = strtok(temp1,"%");		/* Up to 1st token */
   strcpy(temp,p);
   p1 = strtok(NULL,"%");		/* Up to 2nd token */

/* Parse protocol string and build command line */
   while (*p1) {
      switch (tolower(p1[0])) {
         case 'a':		/* Append full pathname of destination */
            if (tdir[0]) 
               strcat(temp,tdir);
            else {
               getcwd(fname,_MAX_PATH);
               strcat(temp,fname);
            }
            strcat(temp,"\\");
            if (QWKDir[0]) {
               strcat(temp,QWKDir);
               strcat(temp,"\\");
            }
            strcat(temp,tname);
            break;

         case 'p':
            sprintf(portstr,"%d",prm.com_port + 1);		/* Com1 or com2 */
            strcat(temp,portstr);
            break;

         case 'b':
            sprintf(portstr,"%d",LastUser.flag);		/* Baudrate */
            strcat(temp,portstr);
            break;

         default:
            strcat(temp,p1);
            break;
      }
      p1++;
      if (*p1)
         strcat(temp,p1);
      strcat(temp," ");
      p1 = strtok(NULL,"%");		/* Up to 2nd token */
   }

   sprintf(temp1,"\r\n%s file must be in either PkZip,LHARC or ARC format.\r\n",tname);
   strout(temp1);
   strout("Ready to upload REP packet? [Y,n] -> ");
   x = chrin();
   if (isalpha(x))
      x &= 0x00df;		/* Force upper case, toupper() has side effects */
   strout("\r\n");
   if (x == 0x0d)
      x = 'Y';

   if (x == 'Y') {
      if (!IsLocal) {
         sprintf(temp1,"Receiving %s packet using %s",tname,upl1->protoname);
         logit(temp1,'=');
         sprintf(temp1,"Prepare to upload %s file using %s \r\n",tname,upl1->protoname);
         strout(temp1);
      }
      else {
         sprintf(temp1,"\nSince you are in local mode here, enter full pathname for %s packet.\r\n",tname);
         strout(temp1);
         strout("And I will copy it over and process it. Include drive also.\r\n");
         timeremain();
         setcolor(TextAttr[PROMPT_TEXT]);
         strout("--> ");
         strin(temp1);
         stripwhite(temp1);
         if (temp1[0]) {
            if(copy2temp(temp1))	 {	/* Was it ok? */
               setcolor(TextAttr[ATTN_TEXT]);
               strout("\r\nInvalid filename given.\r\n");
               return FALSE;
            }
            else {
               sprintf(temp,"Receiving %s packet from local user",temp1);
               logit(temp,'=');
               strout("\nWould you like me to delete your REP packet now? ");
               if (getyn(FALSE)) 
                  unlink(temp1);
               return TRUE;
            }
         }
         else return FALSE;
      }

      delay_s(2);		/* Make sure string is displayed to user */

      printf("Command line: %s %s\n",fname,temp);

   /* Execute the protocol engine */
      FossilDeInit();		/* Remove fossil from us */

      tempdir();
      if (SwapMode) {
         sprintf(temp1,"Maxmal%02x.swp",Task);
         x = swap(fname,temp,&exec_ret,temp1);
      }
      else {		/* We must do a DOS exec function */
         strcpy(temp1,fname);
         strcat(temp1,temp);
         x = system(temp1);
         exec_ret = (char) x;
      }

      homedir();
      FossilInit();		/* Restart fossil for us */

      if (x || exec_ret) {
         setcolor(TextAttr[ATTN_TEXT]);
         strout("\r\nOh Oh! Xfer program had some kind of error\r\n");
         sprintf(temp,"Xfer pgm error code: %d, swap error: %d",exec_ret,x);
         logit(temp,'!');
         return(-1);
      }
      else {
         setcolor(TextAttr[HILITE_TEXT]);
         strout("\r\nNo errors occured during transfer.\r\n");
         return(TRUE);
      }
   }
   else return FALSE;
}

unsigned _pascal get_msgcount(void)
{
   unsigned x;

   x = 0;
   msgupd = MSGUPD_1;
   USERCFG.totselareas = 0;		/* Re-do this while we are at it */
   while (msgupd) {
      USERCFG.totselareas++;
      x += msgupd->msgcount;
      msgupd = msgupd->next;
   }
   return x;
}

void _pascal newuser_help(void)
{
   show_file(NewHelpFil,FALSE);
}

/* Display file to user, allow optional escape from display */

int _pascal show_file(char *strng,int mode)
{
   FILE *newfile;
   int linecount;
   int esc;
   char ltemp[82];
   char *p;

   if (strng[0] == '\0')
      return(-1);		/* No help file */

   esc = FALSE;
   newfile = _fsopen(strng,"r",SH_DENYNO);		/* Open in read only, text mode */
   if (newfile == NULL) {
      sprintf(ltemp,"Error opening %s file for user.",strng);
      logit(ltemp,'!');
      return(-1);		/* Just skip it */
   }

   setcolor(TextAttr[VIEW_TEXT]);
   linecount = 0;
   while (!feof(newfile)) {
      if(fgets(ltemp,80,newfile)) {
         if (linecount > 21) {		/* Turn on more for paging */
            setcolor(7);		/* Basic black and white */
            if (mode) {
               strout("\r\nPress ESC to stop or any other key for more");
               if((chrinwait(1) & 0xff) == 0x1b) {		/* Just return */
                  esc = TRUE;
                  break;
               }
            }
            else {
               strout("\r\nPress any key for more");
               chrinwait(1);
            }
            cleareol();
            strout("\r\n");
            linecount = 0;
            setcolor(TextAttr[VIEW_TEXT]);
         }
         p = strtok(ltemp,"\n");
         if (p) 
            strout(p);
         cleareol();
         setcolor(7);		/* Basic black and white */
         strout("\r\n");
         setcolor(TextAttr[VIEW_TEXT]);
         linecount++;
      }
   }
   fclose(newfile);
   if (!esc) {
      setcolor(7);		/* Basic black and white */
      strout("\r\nPress any key to return");
      chrinwait(1);
   }
   cleareol();
   setcolor(TextAttr[STD_TEXT]);
   strout("\r\n");
   return(0);
}

/* If mode is TRUE, display message area */
struct msgupd_st * _pascal build1_area(int msgnum,int mode)
{
   int keys,mask,x,index;
   struct msgupd_st *this;
   struct _aidx IDX;

   if(is_selarea(msgnum))
      return NULL;
   index = sopen(PRM(aidx_name),O_BINARY | O_RDONLY,SH_DENYNO,S_IREAD);
   if (index == -1)
      aborterror(FILEOPEN,"Error opening Area index file");
   lseek(index,(long) (msgnum * sizeof(struct _aidx)),SEEK_SET);
   if(read(index,(char *)&IDX,sizeof(struct _aidx)) == 0) {
      close(index);
      return NULL;
   }
   if(fseek(afile,IDX.offset,SEEK_SET) != 0) {
      close(index);
      return NULL;
   }
   if(fread(&AREA,astrlen,1,afile) != 1) {
      close(index);
      return NULL;
   }

   mask = 1;
   for (x=0; x < (msgnum % 16); x++)
      mask = mask << 1;
   keys = testlock();
   if (isskiparea(msgnum))
      keys = FALSE; 		/* If Sysop set skip, don't build this area */
   else if(!check_barareas(&AREA,TRUE))
      keys = FALSE;
   if (AREA.msgpath[0] && (LastUser.priv >= AREA.msgpriv) && keys) {
      this = (struct msgupd_st *) malloc(sizeof(struct msgupd_st));
      if (this == NULL)
         aborterror(BADALLOC,NULL);
      this->areano = msgnum;
      strcpy(this->msgpath,AREA.msgpath);
      this->update = FALSE;
      switch (AREA.area_type) {
         case 0:		/* Fido 1.msg style */
            this->himsg = find_fidohigh(AREA.msgpath);
            break;

         default:
            this->himsg = find_fidohigh(AREA.msgpath);
            break;
      }
      this->areaindex = ftell(afile) - (long) astrlen;	/* Position */
      this->next = NULL;
      this->readmsgs = 0;
      this->flags = 0;
      if (isForcearea(msgnum))
         this->flags |= AREA_FORCED;
      this->attribute = (word) AREA.attrib[UserClass];
      if (mode) {
         sprintf(temp1,"\rArea %d: ",msgnum);
         strncat(temp1,AREA.msginfo,55);
         for (x = 65 - strlen(temp1); x; x-- )
            strcat(temp1," ");
         strout(temp1);
      }
      this->startmsg = get_lastread(AREA.msgpath);
      if (this->startmsg < 1)
         this->startmsg = 1;
      if (this->startmsg > this->himsg) 
         this->startmsg = this->himsg;
      this->msgcount = this->himsg - this->startmsg;
   }
   close(index);
   return this;
}



/* Test to see if selected area is barricaded, (Standard OPUS type)
   if so, get password from user and test to see if it is in file.
   If password is rejected UNmark area for user and return FALSE */

/* If MODE is true, this is a new selection. If mode is FALSE,
    check date on barricaded file, if date is newer than lastcall
    then process. If mode == -1, check but don't prompt */

/* Return TRUE if ok to access area, FALSE if not */
int _pascal check_barareas(struct _area *AREA,int mode)
{
   FILE *bfile;
   int count;
   char *p,*pp;

   if (AREA->msgbar[0] == 0)		/* No barricade file */
      return(TRUE);		/* No changes */

   if (mode == -1)		/* Don't prompt, just skip it */
      return(FALSE);		/* No changes */

   if(stat(AREA->msgbar,&fbuf) == 0 ) {		/* File does exist */
      if (!mode) {		/* Check the date on it */
         if (fbuf.st_mtime <= USERCFG.lasttime)		/* See if changed since last logon */
            return(TRUE);		/* No changes */
      }
      bfile = _fsopen(AREA->msgbar,"rt",SH_DENYNO);
      if (bfile == NULL)
         return(TRUE);
      p = getfline(bfile);		/* Fetch 1st line */
      if (p[0] == '!') {		/* This is an EXTENDED barricaded file. Ignore it? */
         fclose(bfile);
         return(ExtendOk);		/* Return what sysop configured for ext barr files */
      }
      
/* Okay, now inform the user this is a barricaded file */
      strncpy(temp1,AREA->msginfo,24);
      sprintf(temp,"\r\n   Message area: '%s' is a protected area\r\n",temp1);
      strout(temp);
      for (count=0; count < 3; count++ ) {		/* Try a password 3 times */
         strout("   Enter password -> ");
         strin(temp1);		/* Fetch it */
         if (!IsLocal)
            strout("\r\n");
         stripwhite(temp1);		/* Strip leading and traling space */
         while (p) {		/* Keep looping through barricaded file till you find it */
            pp = strtok(p," ");		/* Strip out the password */
            if (strcmpi(pp,temp1) == 0) {
               strout("        Password is ok, area is now selected!\r\n");
               fclose(bfile);
               return(TRUE);
            }
            p = getfline(bfile);		/* Fetch next line */
         }
         strout("        Password is rejected. Try again!\r\n");
         rewind(bfile);		/* Restart at top of barricaded file */
         p = getfline(bfile);		/* Fetch 1st line again */
      }
      fclose(bfile);
      return(FALSE);		/* Tried 3 times and failed */
   }
   else {
      fclose(bfile);
      return(TRUE);
   }
}

/* Fetch a line of text from a file. Return NULL if no more
    text lines. Assume file was opened in text mode. Strip any
    leading space in the line. */

char * _pascal getfline(FILE *tfile)
{
   static char fbuff[90];
   char *p;

   p = fgets(fbuff,89,tfile);
   if (p == NULL)
      return(NULL);

   while (*p && isspace(*p))
      p++;
   return(p);
}

void _pascal makearc(char *filename)
{
   char fext[5];
   char *p,*p1;
   int x,y,old,olderr;
   static int packertype=0;
   union REGS regs;
   struct SREGS sregs;

   if (IsLocal)
      ReDirect = FALSE;

   if (FirstArc) {

      regs.h.ah = 0x34;
      intdosx(&regs,&regs,&sregs);		/* Get the DOS busy flag */
      Critseg  =   sregs.es;
      Critoffs =   regs.x.bx;

      if (FirstArc == -1)  {
         free(packtemp);
         free(arccmndline);
      }
      packertype = USERCFG.packer;
      packtemp = (char *) malloc(91);
      if (packtemp == NULL)
         aborterror(BADALLOC,NULL);
      arccmndline = (char *) malloc(91);
      if (arccmndline == NULL)
         aborterror(BADALLOC,NULL);
   }

   if (!packertype) {	/* Must ask, but fix it so we only ask once */
      get_packer(FALSE);
      packertype = USERCFG.packer;
   }

   x = USERCFG.packer;
   USERCFG.packer = (byte) packertype;
   packer1 = get_curpacklnk();
   USERCFG.packer = (byte) x;

   if (FirstArc) {
      if (ReDirect) {
         if (prm.com_port <= 3) {		/* Can only redirect to com1,2,3 or 4 */
      /* Try Gateway device first */
            sprintf(packtemp,"GATE%d",prm.com_port+1);		/* Make com1,com2 etc */
            if ((comhandle = open(packtemp,O_RDWR,S_IWRITE)) >= 0) {
               _asm {
                  mov   ax,4400h		/* IOCTL device inquire */
                  mov   dx,comhandle
                  int   21h
                  mov   x,dx
               }
               if ((x & 0x0080) == 0) {		/* Device bit */
                  close(comhandle);
                  comhandle = -1;		/* Disable then if not device */
               }
            }
            else {		/* Nope, then try standard COM devices */
               sprintf(packtemp,"COM%d",prm.com_port+1);		/* Make com1 or com2 */
               if ((comhandle = open(packtemp,O_RDWR,S_IWRITE)) >= 0) {
                  _asm {
                     mov   ax,4400h  /* IOCTL device inquire */
                     mov   dx,comhandle
                     int   21h
                     mov   x,dx
                  }
                  if ((x & 0x0080) == 0) {		/* Device bit */
                     close(comhandle);
                     comhandle = -1;		/* Disable then if not device */
                  }
               }
            }
         }
      }
      _splitpath(packer1->packpname,packtemp,packtemp,fname,fext);
      x = strlen(fname);
      x = x <= 6 ? x : 6;
      strncpy(ArcFile,fname,x);
      ArcFile[x] = '\0';

      old =  USERCFG.packcount;
      while (old > 99) 
         old -= 100;
      sprintf(packtemp,"%02d",old);
      strcat(ArcFile,packtemp);
      strcat(ArcFile,fext);

      tempdir();
      while(stat(ArcFile,&fbuf) == 0 ) { 	/* Uh oh. File exists! try next one */
         strncpy(ArcFile,fname,x);
         ArcFile[x] = '\0';
         sprintf(packtemp,"%02d",++old);
         strcat(ArcFile,packtemp);
         strcat(ArcFile,fext);
      }

      homedir();

      if (SwapMode) {		/* We must use command.com to exec if swapper is on */
         if (Command) {
            strcpy(fname,"C:\\command.com");		/* Look for it on boot first */
            if (!stat(fname,&fbuf)) {		/* Nope, so look in path */
               _searchenv("Command.com","PATH",fname);
               if (*fname == '\0') {
                  if (comhandle >= 0)
                     close(comhandle);
                  aborterror(BADEXEC,NULL);
               }
            }
         }
         else {
            _searchenv(packer1->packexe,"PATH",fname);
            if (*fname == '\0') {
               if (comhandle >= 0)
                  close(comhandle);
               logit("Error trying to locate packer program",'!');
               aborterror(BADEXEC,NULL);
            }
            strcpy(arccmndline," ");
         }
      }
      else {
         strcpy(fname,packer1->packexe);
         arccmndline[0] = 0;
      }

   /* All this junk to parse packer command line and build execute string */
      strcpy(packtemp,packer1->packstring);
      p = strtok(packtemp,"%");		/* Up to 1st token */
      strcat(arccmndline,p);
      strcat(arccmndline," ");
      p1 = strtok(NULL,"%");		/* Up to 2nd token */
      if (tolower(p1[0]) == 'a') 	/* Arcfile */
         strcat(arccmndline,ArcFile);
      strcat(arccmndline," ");
   }

   printf("Command line: %s %s %s\n",fname,arccmndline,filename);

/* Prepare to execute the packer to arc up the file */

   tempdir();
   if (comhandle >= 0) {
      setcolor(TextAttr[VIEW_TEXT]);
      old = dup(1);		/* old now refers to stdout */
      olderr = dup(2);		/* olderr now refers to stderr */
      if(dup2(comhandle,1) != 0) /* Reroute stdout to com port */
         comhandle = -1;		/* Some kind of error */
      else dup2(comhandle,2); /* Reroute stderr to com port */
   }

   y = strlen(arccmndline);
   strcat(arccmndline,filename); /* incoming filename */

/* Here's the actual DOS exec */

   if (WatchDog) {
      OldTimer = _dos_getvect(0x1c);
      _dos_setvect(0x1c,CheckWatch);
   }

   if (SwapMode) {
      sprintf(packtemp,"Maxmal%02x.swp",Task);
      x = swap(fname,arccmndline,&exec_ret,packtemp);
   }
   else {
      strcpy(packtemp,fname);
      strcat(packtemp," ");
      strcat(packtemp,arccmndline);
      x = system(packtemp);
      exec_ret = (char) x;
   }

   if (WatchDog) {
      _dos_setvect(0x1c,OldTimer);
   }

   arccmndline[y] = 0;		/* Strip out filename */

   homedir();

   if (comhandle >= 0) {
      dup2(old,1);		/* Restore stdout */
      dup2(olderr,2);		/* Restore stderr */
      setcolor(TextAttr[STD_TEXT]);
   }

   check_carrier();

   if (x || exec_ret) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nOh Oh! Packer had some kind of error\r\n");
      strout("Shipping you back to Maximus!\r\n\r\n");
      sprintf(packtemp,"Packer error code: %d, swap error: %d",exec_ret,x);
      logit(packtemp,'!');
      if (comhandle >= 0)
         close(comhandle);
      aborterror(BADEXEC,"Error executing packer program");
   }

   if (FirstArc)
      FirstArc = FALSE;
}


int _pascal extractarc(char *name)
{
   char *p,*p1;
   int x,old,olderr;
   char *extractemp;
   char *cmndline;
   static char tname[13];
   static struct reparc_st *reparc1;

   if (IsLocal)
      ReDirect = FALSE;

/* We need to figure out what type of archive it is */

   strcpy(tname,name);

   extractemp = (char *) malloc(91);
   if (extractemp == NULL)
      aborterror(BADALLOC,NULL);
   cmndline = (char *) malloc(91);
   if (cmndline == NULL)
      aborterror(BADALLOC,NULL);

   x = sopen(tname,O_BINARY | O_RDONLY,SH_DENYNO,S_IREAD);
   if (x < 0)
      return -1;		/* Some kind of error */

/* Look at first few bytes */
   read(x,extractemp,10);		/* Read 10 bytes */
   strncpy(cmndline,extractemp,2);
   cmndline[2] = 0;
   if (strcmp(cmndline,"PK") == 0) 		/* Is it ZIP? */
      reparc1 = ZIPREP;
   else {
      strncpy(cmndline,extractemp+2,3);
      cmndline[3] = 0;
      if (strcmp(cmndline,"-lh") == 0) /* Is it LHA? */
         reparc1 = LHAREP;
      else reparc1 = ARCREP;
   }
   close(x);


   if (ReDirect) {
      if (prm.com_port <= 3) {		/* Can only redirect to com1,2,3 or 4 */
   /* Try Gateway device first */
         sprintf(extractemp,"GATE%d",prm.com_port+1);		/* Make com1,com2 etc */
         if (comhandle == -1) {
            if ((comhandle = open(extractemp,O_RDWR,S_IWRITE)) >= 0) {
               _asm {
                  mov   ax,4400h		/* IOCTL device inquire */
                  mov   dx,comhandle
                  int   21h
                  mov   x,dx
               }
               if ((x & 0x0080) == 0) {		/* Device bit */
                  close(comhandle);
                  comhandle = -1;		/* Disable then if not device */
               }
            }
            else {		/* Nope, then try standard COM devices */
               sprintf(extractemp,"COM%d",prm.com_port+1);		/* Make com1 or com2 */
               if ((comhandle = open(extractemp,O_RDWR,S_IWRITE)) >= 0) {
                  _asm {
                     mov   ax,4400h  /* IOCTL device inquire */
                     mov   dx,comhandle
                     int   21h
                     mov   x,dx
                  }
                  if ((x & 0x0080) == 0) {		/* Device bit */
                     close(comhandle);
                     comhandle = -1;		/* Disable then if not device */
                  }
               }
            }
         }
      }
   }

   if (SwapMode) {		/* We must use command.com to exec if swapper is on */
      if (Command) {
         strcpy(fname,"C:\\command.com");		/* Look for it on boot first */
         if (!stat(extractemp,&fbuf)) {		/* Nope, so look in path */
            _searchenv("Command.com","PATH",fname);
            if (*fname == '\0') {
               if (comhandle >= 0)
                  close(comhandle);
               aborterror(BADEXEC,"No command.com");
            }
         }
         sprintf(cmndline," /c %s",reparc1->packexe);
      }
      else {
         _searchenv(reparc1->packexe,"PATH",fname);
         if (*fname == '\0') {
            if (comhandle >= 0)
               close(comhandle);
            aborterror(BADEXEC,NULL);
         }
         strcpy(cmndline," ");
      }
   }
   else {
      strcpy(fname,reparc1->packexe);
      cmndline[0] = 0;
   }

/* All this junk to parse packer command line and build execute string */
   strcpy(extractemp,reparc1->packstring);
   p = strtok(extractemp,"%");		/* Up to 1st token */
   strcat(cmndline,p);
   strcat(cmndline," ");
   p1 = strtok(NULL,"\r\n");
   if (tolower(p1[0]) == 'a') /* Arcfile name */
      strcat(cmndline,tname);
   strcat(cmndline," ");

   printf("Command line: %s %s\n",fname,cmndline);

/* Prepare to execute the packer to extract the file */

   if (comhandle >= 0) {
      setcolor(TextAttr[VIEW_TEXT]);
      old = dup(1);		/* old now refers to stdout */
      olderr = dup(2);		/* olderr now refers to stderr */
      if(dup2(comhandle,1) != 0) /* Reroute stdout to com port */
         comhandle = -1;		/* Some kind of error */
      else dup2(comhandle,2); /* Reroute stderr to com port */
   }


/* Here's the actual DOS exec */

   if (SwapMode) {
      sprintf(extractemp,"Maxmal%02x.swp",Task);
      x = swap(fname,cmndline,&exec_ret,extractemp);
   }
   else {
      strcpy(extractemp,fname);
      strcat(extractemp," ");
      strcat(extractemp,cmndline);
      x = system(extractemp);
      exec_ret = (char) x;
   }

   if (comhandle >= 0) {
      dup2(old,1);		/* Restore stdout */
      dup2(olderr,2);		/* Restore stderr */
   }

   check_carrier();

   old = 0;

   if (x || exec_ret) {
      setcolor(TextAttr[ATTN_TEXT]);
      strout("\r\nOh Oh! Packer had some kind of error\r\n");
      sprintf(extractemp,"Packer error code: %d, swap error: %d",exec_ret,x);
      logit(extractemp,'!');
      old = 1;
   }
   free(extractemp);
   free(cmndline);
   if (comhandle >= 0)
      setcolor(TextAttr[STD_TEXT]);
   return old;
}


#pragma check_stack( off )
#pragma check_pointer( off )
#pragma intrinsic( _enable, _disable )

void _interrupt _far CheckWatch(void)
{
   _asm {		/* Check carrier */
      mov   bx, OFFSET prm
      mov   dx,[bx]prm.com_port
      mov   ah,3		/* Get modem status */
      int   14h
      test  al,80h
      jnz   leave1		/* Everything's fine */

      push  es
      mov   ax,Critseg
      mov   es,ax
      mov   bx,Critoffs
      mov   ax,es:[bx]
      pop   es
      cmp   ax,0
      jnz   leave1

      mov   ax,4c01h		/* Force a drop out */
      int   21h

      leave1:
   }

   _chain_intr(OldTimer);
}

